package com.displaynone.acss.components.acs.models.visit

import android.content.Context
import com.displaynone.acss.components.acs.models.visit.repository.VisitRepository
import com.displaynone.acss.components.acs.models.visit.repository.dto.VisitDto
import com.displaynone.acss.components.auth.internal_utils.AuthTokenManager
import com.displaynone.acss.components.auth.internal_utils.UserManager
import com.displaynone.acss.components.auth.models.user.UserServiceST

class VisitServiceST {
    companion object {
        private var instance: VisitServiceST? = null

        fun createInstance() {
            if (instance == null) {
                instance = VisitServiceST()
            }
        }

        fun getInstance(): VisitServiceST {
            return instance ?: throw RuntimeException("null instance")
        }
    }
    private val visitRepository: VisitRepository = VisitRepository()
    suspend fun getLastVisitsByLogin(pageNum: Int,
                                     pageSize: Int,
                                     login: String): Result<List<VisitDto>> {
        if (!UserServiceST.getInstance().hasTokens()) {
            throw RuntimeException("access token is null")
        }
        return visitRepository.getLastVisitsByLogin(pageNum, pageSize, UserServiceST.getInstance().getTokenPair()!!.accessToken, login).map { pagingDto -> pagingDto.content }
    }
    suspend fun getMyLastVisits(pageNum: Int,
                                pageSize: Int): Result<List<VisitDto>> {
        if (!UserServiceST.getInstance().hasTokens()) {
            throw RuntimeException("access token is null")
        }

        return visitRepository.getMyLastVisits(
            pageNum = pageNum,
            pageSize = pageSize,
            token = UserServiceST.getInstance().getTokenPair()!!.accessToken
        ).map { pagingDto -> pagingDto.content }
    }
}